#!/usr/bin/python

import sys
import dtbocreator as ovlc

dtsfile = ovlc.DtsFile(sys.argv[1] if len(sys.argv) >= 2 else "stdout")
overlay = ovlc.Overlay(dtsfile, "SPI_Custom", ["nvidia,p3449-0000-b00+p3448-0000-b00", "nvidia,p3449-0000-a02+p3448-0000-a02"])

frag1 = ovlc.SPIMasterController(overlay, "spi0")
frag1.setDefaultPins()
frag1.setPollingMode(True)
slave1 = ovlc.SPIDeviceSPIDEV(frag1, "spi@0", 0x0, 20000000)
slave1.addControllerAttribute("nvidia,cs-setup-clk-count", 5)
slave1.addControllerAttribute("nvidia,cs-hold-clk-count", 5)
slave1.addControllerAttribute("nvidia,cs-inactive-cycles", 5)

frag2 = ovlc.SPISlaveController(overlay, "spi1")
frag2.setDefaultPins()
slave11 = ovlc.SPIDeviceSPIDEV(frag2, "spi@0", 0x0, 20000000)
slave11.addControllerAttribute("nvidia,cs-setup-clk-count", 5)
slave11.addControllerAttribute("nvidia,cs-hold-clk-count", 5)

dtsfile.save()

