import sys
import io
import os
from dtobject import DtObject
from fragment import Fragment

class Device(DtObject):
	"""
	Create a new generic Device which will be rendered as:
		<name>: {
		}

	Args:
		parent: (:obj:`DtObject`)
			The Fragment or Device that will contain this Device
		name: (:obj:`str`)
			The name of the device.

	Returns:
		:obj:`Device`: A new Device object
	"""
	def _print(self, indent, file_desc=sys.stdout):
		tabs = "".rjust(indent, '\t')
		file_desc.write("%s%s {\n" % (tabs, self.name))
		for aname, a in self.attributes.items():
			a._print(indent + 1, file_desc=file_desc)
		for oname, o in self.objects.items():
			o._print(indent + 1, file_desc=file_desc)
			
		tabs = "".rjust(indent, '\t')
		file_desc.write("%s};\n" % tabs)
