import sys
import io
import os
from attribute import *
from dtobject import DtObject

class Fragment(DtObject):
	def __init__(self, parent, name, target=None):
		DtObject.__init__(self, parent, "fragment@" + name)
		if not target:
			target = name
		self.addAttribute(AddrAttribute("target", target))
		
	def _print(self, indent, file_desc=sys.stdout):
		tabs = "".rjust(indent, '\t')
		file_desc.write("%s%s {\n" % (tabs, self.name))
		target = self.getAttribute("target")
		target._print(indent + 1, file_desc=file_desc)

		tabs = "".rjust(indent + 1, '\t')
		file_desc.write("%s__overlay__ {\n" % tabs)
		for aname, a in self.attributes.items():
			if aname != "target":
				a._print(indent + 2, file_desc=file_desc)
		for oname, o in self.objects.items():
			o._print(indent + 2, file_desc=file_desc)

		file_desc.write("%s};\n" % tabs)
		tabs = "".rjust(indent, '\t')
		file_desc.write("%s};\n" % tabs)
