from ..pin import *

class SPIDefaultPins(object):

	@staticmethod
	def _spi0_master(pinmux):
		pinmux.addPin("pin19", "spi1", "spi1_mosi_pc0", "TEGRA_PIN_PULL_DOWN",	False, False)
		pinmux.addPin("pin21", "spi1", "spi1_miso_pc1", "TEGRA_PIN_PULL_NONE",	True,  True)
		pinmux.addPin("pin23", "spi1", "spi1_sck_pc2",  "TEGRA_PIN_PULL_DOWN",	False, False)
		pinmux.addPin("pin24", "spi1", "spi1_cs0_pc3",  "TEGRA_PIN_PULL_UP", 	False, False)
		pinmux.addPin("pin26", "spi1", "spi1_cs1_pc4",  "TEGRA_PIN_PULL_UP",	False, False)

	@staticmethod
	def _spi0_slave(pinmux):
		pinmux.addPin("pin19", "spi1", "spi1_mosi_pc0", "TEGRA_PIN_PULL_NONE", True, True)
		pinmux.addPin("pin21", "spi1", "spi1_miso_pc1", "TEGRA_PIN_PULL_DOWN", True, False)
		pinmux.addPin("pin23", "spi1", "spi1_sck_pc2",  "TEGRA_PIN_PULL_NONE", True, True)
		pinmux.addPin("pin24", "spi1", "spi1_cs0_pc3",  "TEGRA_PIN_PULL_NONE", True, True)
		pinmux.addPin("pin26", "spi1", "spi1_cs1_pc4",  "TEGRA_PIN_PULL_NONE", True, True)
		
	@staticmethod
	def _spi1_master(pinmux):
		pinmux.addPin("pin37", "spi2", "spi2_mosi_pb4", "TEGRA_PIN_PULL_DOWN", 	False, False)
		pinmux.addPin("pin22", "spi2", "spi2_miso_pb5", "TEGRA_PIN_PULL_NONE", 	True,  True)
		pinmux.addPin("pin13", "spi2", "spi2_sck_pb6",  "TEGRA_PIN_PULL_DOWN", 	False, False)
		pinmux.addPin("pin18", "spi2", "spi2_cs0_pb7",  "TEGRA_PIN_PULL_UP",	False, False)
		pinmux.addPin("pin66", "spi2", "spi2_cs1_pdd0", "TEGRA_PIN_PULL_UP",	False, False)
	
	@staticmethod
	def _spi1_slave(pinmux):
		pinmux.addPin("pin37", "spi2", "spi2_mosi_pb4", "TEGRA_PIN_PULL_NONE", True, True)
		pinmux.addPin("pin22", "spi2", "spi2_miso_pb5", "TEGRA_PIN_PULL_DOWN", True, False)
		pinmux.addPin("pin13", "spi2", "spi2_sck_pb6",  "TEGRA_PIN_PULL_NONE", True, True)
		pinmux.addPin("pin18", "spi2", "spi2_cs0_pb7",  "TEGRA_PIN_PULL_NONE", True, True)
		pinmux.addPin("pin16", "spi2", "spi2_cs1_pdd0", "TEGRA_PIN_PULL_NONE", True, True)
	
def setDefaultPins(device, role, pinmux):
	pinsfunc = getattr(SPIDefaultPins, "_"+device+"_"+role)
	pinsfunc(pinmux)
